/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoNLpackGeneratorTranslateXliffByPleiades]のクラス
 */
package blanco.nlpack.generator.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.nlpack.generator.task.valueobject.BlancoNLpackGeneratorTranslateXliffByPleiadesProcessInput;

/**
 * Apache Antタスク [BlancoNLpackGeneratorTranslateXliffByPleiades]のクラス。
 *
 * [XLIFF対応ツール] Pleiadesを使って XLIFFファイル(*.xlf)を翻訳します。Pleiadesを使って翻訳できた場合、XLIFFファイルの targetを記入します。targetが既に存在する場合には、alt-transに記入します。(同一 tool-id で targetの内容に変化があった場合にのみセットします) セットした場合、target の state には needs-review-translation をセットします。(alt-transの場合にはセットせず)<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.nlpack.generator.task]にBlancoNLpackGeneratorTranslateXliffByPleiadesBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blanconlpackgeneratortranslatexliffbypleiades&quot; classname=&quot;blanco.nlpack.generator.task.BlancoNLpackGeneratorTranslateXliffByPleiadesTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoNLpackGeneratorTranslateXliffByPleiadesTask extends Task {
    /**
     * [XLIFF対応ツール] Pleiadesを使って XLIFFファイル(*.xlf)を翻訳します。Pleiadesを使って翻訳できた場合、XLIFFファイルの targetを記入します。targetが既に存在する場合には、alt-transに記入します。(同一 tool-id で targetの内容に変化があった場合にのみセットします) セットした場合、target の state には needs-review-translation をセットします。(alt-transの場合にはセットせず)
     */
    protected BlancoNLpackGeneratorTranslateXliffByPleiadesProcessInput fInput = new BlancoNLpackGeneratorTranslateXliffByPleiadesProcessInput();

    /**
     * [XLIFF対応ツール] Pleiadesを使って XLIFFファイル(*.xlf)を翻訳します。Pleiadesを使って翻訳できた場合、XLIFFファイルの targetを記入します。targetが既に存在する場合には、alt-transに記入します。(同一 tool-id で targetの内容に変化があった場合にのみセットします) セットした場合、target の state には needs-review-translation をセットします。(alt-transの場合にはセットせず)
     */
    protected boolean fIsFieldXliffdirProcessed = false;

    /**
     * [XLIFF対応ツール] Pleiadesを使って XLIFFファイル(*.xlf)を翻訳します。Pleiadesを使って翻訳できた場合、XLIFFファイルの targetを記入します。targetが既に存在する場合には、alt-transに記入します。(同一 tool-id で targetの内容に変化があった場合にのみセットします) セットした場合、target の state には needs-review-translation をセットします。(alt-transの場合にはセットせず)
     */
    protected boolean fIsFieldTmpdirProcessed = false;

    /**
     * [XLIFF対応ツール] Pleiadesを使って XLIFFファイル(*.xlf)を翻訳します。Pleiadesを使って翻訳できた場合、XLIFFファイルの targetを記入します。targetが既に存在する場合には、alt-transに記入します。(同一 tool-id で targetの内容に変化があった場合にのみセットします) セットした場合、target の state には needs-review-translation をセットします。(alt-transの場合にはセットせず)
     */
    protected boolean fIsFieldSettargetProcessed = false;

    /**
     * [XLIFF対応ツール] Pleiadesを使って XLIFFファイル(*.xlf)を翻訳します。Pleiadesを使って翻訳できた場合、XLIFFファイルの targetを記入します。targetが既に存在する場合には、alt-transに記入します。(同一 tool-id で targetの内容に変化があった場合にのみセットします) セットした場合、target の state には needs-review-translation をセットします。(alt-transの場合にはセットせず)
     */
    protected boolean fIsFieldSettargetoverwriteProcessed = false;

    /**
     * [XLIFF対応ツール] Pleiadesを使って XLIFFファイル(*.xlf)を翻訳します。Pleiadesを使って翻訳できた場合、XLIFFファイルの targetを記入します。targetが既に存在する場合には、alt-transに記入します。(同一 tool-id で targetの内容に変化があった場合にのみセットします) セットした場合、target の state には needs-review-translation をセットします。(alt-transの場合にはセットせず)
     */
    protected boolean fIsFieldSetalttransProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * XLIFFファイルが格納されている入力／出力先ルート・フォルダを指定します。XLIFFファイルは Bundle-SymbolicName ディレクトリ内に格納されることを前提とします。<br>
     *
     * @param arg セットしたい値
     */
    public void setXliffdir(final String arg) {
        fInput.setXliffdir(arg);
        fIsFieldXliffdirProcessed = true;
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * XLIFFファイルが格納されている入力／出力先ルート・フォルダを指定します。XLIFFファイルは Bundle-SymbolicName ディレクトリ内に格納されることを前提とします。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getXliffdir() {
        return fInput.getXliffdir();
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     *
     * @param arg セットしたい値
     */
    public void setTmpdir(final String arg) {
        fInput.setTmpdir(arg);
        fIsFieldTmpdirProcessed = true;
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     * デフォルト値[tmp]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTmpdir() {
        return fInput.getTmpdir();
    }

    /**
     * Antタスクの[settarget]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * trans-unit の target について、値をセットするかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setSettarget(final boolean arg) {
        fInput.setSettarget(arg);
        fIsFieldSettargetProcessed = true;
    }

    /**
     * Antタスクの[settarget]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * trans-unit の target について、値をセットするかどうか。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getSettarget() {
        return fInput.getSettarget();
    }

    /**
     * Antタスクの[settargetoverwrite]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * trans-unit の target について、存在の有無にかかわらず値をセットするかどうか。翻訳物を強制的に上書きする場合においてのみセットされます。<br>
     *
     * @param arg セットしたい値
     */
    public void setSettargetoverwrite(final boolean arg) {
        fInput.setSettargetoverwrite(arg);
        fIsFieldSettargetoverwriteProcessed = true;
    }

    /**
     * Antタスクの[settargetoverwrite]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * trans-unit の target について、存在の有無にかかわらず値をセットするかどうか。翻訳物を強制的に上書きする場合においてのみセットされます。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getSettargetoverwrite() {
        return fInput.getSettargetoverwrite();
    }

    /**
     * Antタスクの[setalttrans]アトリビュートのセッターメソッド。
     *
     * 項目番号: 5<br>
     * alt-trans をセットするかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setSetalttrans(final boolean arg) {
        fInput.setSetalttrans(arg);
        fIsFieldSetalttransProcessed = true;
    }

    /**
     * Antタスクの[setalttrans]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 5<br>
     * alt-trans をセットするかどうか。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getSetalttrans() {
        return fInput.getSetalttrans();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoNLpackGeneratorTranslateXliffByPleiadesTask begin.");

        // 項目番号[1]、アトリビュート[xliffdir]は必須入力です。入力チェックを行います。
        if (fIsFieldXliffdirProcessed == false) {
            throw new BuildException("必須アトリビュート[xliffdir]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- xliffdir:[" + getXliffdir() + "]");
            System.out.println("- tmpdir:[" + getTmpdir() + "]");
            System.out.println("- settarget:[" + getSettarget() + "]");
            System.out.println("- settargetoverwrite:[" + getSettargetoverwrite() + "]");
            System.out.println("- setalttrans:[" + getSetalttrans() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoNLpackGeneratorTranslateXliffByPleiadesProcessインタフェースを実装して blanco.nlpack.generator.taskパッケージに BlancoNLpackGeneratorTranslateXliffByPleiadesProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoNLpackGeneratorTranslateXliffByPleiadesProcess proc = new BlancoNLpackGeneratorTranslateXliffByPleiadesProcessImpl();
            if (proc.execute(fInput) != BlancoNLpackGeneratorTranslateXliffByPleiadesBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
